require 'cht-chaphql'
require 'cht-chaphql/graphql_formatters'

PRICING_FMTRS =
  YAML.load_file(File.join(__dir__, '../helpers/formatters.yml'))

# module for pricing
module ChtApitestPricing
  include Chaphql
  include Chaphql::GraphQLHelpers

  # module for your shortcuts
  module PricingHelpers
    # insertion point for shortcuts

    def get_aws_ec2_rate(args = {})
      args[:service] = PricingService.new
      sym = first_no_cap(camelize('get_aws_ec2_rate')).to_sym
      headers = {}
      data = format_request(sym, args)
      variables = { queryReq: { capacityStatus: args[:capacityStatus], customerId: args[:customerId], instanceFamily: args[:instanceFamily], instanceType: args[:instanceType], leaseContractLength: args[:leaseContractLength], offeringClass: args[:offeringClass], payerAccountId: args[:payerAccountId], priceOn: args[:priceOn], purchaseOption: args[:purchaseOption], region: args[:region], tenancy: args[:tenancy] } }
      graphql url(args), data, variables, headers, args
      expect_success_graphql
      check(sym, args)
      json_body[:data][sym]
    end

    # end of shortcut insertion
  end

  # class for your service
  class PricingService < ChtNgService
    include RSpec::Matchers

    PRICING_DEFAULTS = {
      name: 'Pricing',
      default_namespace: 'pricing',
      service_name: 'pricing',
      pr_parent: 'pricing',
      formatters: PRICING_FMTRS['formatters'],
      checkers: PRICING_FMTRS['checkers'],
      component_name: 'web-server',
    }.freeze
    def initialize(args = {})
      super(args.merge(PRICING_DEFAULTS))
    end
  end

  # class for api-proxy support of pricing service
  class ApiProxyPricing < ChtNgService
    include RSpec::Matchers

    API_PROXY_DEFAULTS = {
      name: 'ApiProxyPricing',
      namespace: 'api-proxy',
      service_name: 'api-proxy',
      formatters: PRICING_FMTRS['formatters'],
      checkers: PRICING_FMTRS['checkers'],
      default_namespace: 'api-proxy',
      pr_parent: 'api-proxy'
    }.freeze
    def initialize(args = {})
      super(args.merge(API_PROXY_DEFAULTS))
    end
  end
end
