require 'spec_helper'

module PricingTest
  describe 'Pricing' do
    include_context 'request metadata'
# TODO: https://cloudhealthtech.atlassian.net/browse/ZEUS-5915
    it 'Bulk API Query to get OD Price for EDP Customer' do
      wrap_request do
        variables = {
          'queryReq': {
             'customerId': 57534,
            'payerAccountId': 'ALL',
            'purchaseOption': 'ON_DEMAND',
            'capacityStatus': 'USED',
            'region': 'us-east-1',
            'instanceType': 't2.micro',
            'projections': [
                "id",
                "instanceType",
                "locationName",
                "tenancy",
                "chDerivedName",
                "publicRate",
                "discountedRate"
            ]
          }
        }
        graphql url(service: service),
                format_request(
                  :bulkGetAwsEc2Rate,
                  service: service
                ),
                variables, apitest_headers
        expect_success_graphql
        check(:bulkGetAwsEc2Rate, service: service)

        expect_json 'data.bulkGetAwsEc2Rate',
                    contentLength: -> (contentLength){ expect(contentLength).to be > 0 },
                    contentType: 'application/json-lines'
      end
    end

    it 'Bulk API Query to get ALL Upfront RI Price for Non-EDP Customer' do
      wrap_request do
        variables = {
            'queryReq': {
                'customerId': 57534,
                'payerAccountId': '146708650527',
                'purchaseOption': 'AWS_ALL_UPFRONT',
                'region': 'ap-south-1',
                'projections': [
                    "id",
                    "instanceType",
                    "locationName",
                    "tenancy",
                    "chDerivedName",
                    "publicRate",
                    "discountedRate"
                ]
            }
        }
        graphql url(service: service),
                format_request(
                    :bulkGetAwsEc2Rate,
                    service: service
                ),
                variables, apitest_headers
        expect_success_graphql
        check(:bulkGetAwsEc2Rate, service: service)

        expect_json 'data.bulkGetAwsEc2Rate',
                    contentLength: -> (contentLength){ expect(contentLength).to be > 0 },
                    contentType: 'application/json-lines'
      end
    end
  end
end
