require 'spec_helper'

module PricingTest
  describe 'Pricing' do
    include_context 'request metadata'
    it 'Bulk API Query to get ECS OD Price for Non-EDP Customer' do
      wrap_request do
        variables = {
          'queryReq': {
             'customerId': 57534,
            'payerAccountId': 'ALL',
            'purchaseOption': 'ON_DEMAND',
            'region': 'us-east-1',
            'productCode': 'AmazonECS',
            'productFamily': 'Compute',
            'projections': [
                "id",
                "publicRate",
                "discountedRate",
                "purchaseOption",
                "tenancy",
                "productFamily",
            ]
          }
        }
        graphql url(service: service),
                format_request(
                  :bulkGetAwsLeasableComputeProductRate,
                  service: service
                ),
                variables, apitest_headers
        expect_success_graphql
        check(:bulkGetAwsLeasableComputeProductRate, service: service)

        expect_json 'data.bulkGetAwsLeasableComputeProductRate',
                    contentLength: -> (contentLength){ expect(contentLength).to be > 0 },
                    contentType: 'application/json-lines'
      end
    end
  end
end
