require 'spec_helper'

module SPBulkAPIEC2PricingTest
  describe 'Bulk API Savings Plans EC2 Pricing' do
    include_context 'request metadata'
    it 'Bulk API Query to get SP EC2 Price for ComputeSavingsPlans' do
      wrap_request do
        variables = {
          'queryReq': {
            'customerId': 57534,
            'payerAccountId': 'ALL',
            'discountedProductCode': 'AmazonEC2',
            'productFamily': 'ComputeSavingsPlans',
            'purchaseOption': 'AWS_NO_UPFRONT',
            'region': 'af-south-1'
          }
        }
        graphql url(service: service),
                format_request(
                  :bulkGetSavingsPlanProductRates,
                  service: service
                ),
                variables, apitest_headers
        expect_success_graphql
        check(:bulkGetSavingsPlanProductRates, service: service)

        expect_json 'data.bulkGetSavingsPlanProductRates',
                    contentLength: -> (contentLength){ expect(contentLength).to be > 0 },
                    contentType: 'application/json-lines'
      end
    end

    it 'Bulk API Query to get SP EC2 Price for EC2InstanceSavingsPlans' do
      wrap_request do
        variables = {
            'queryReq': {
                'customerId': 57534,
                'payerAccountId': 'ALL',
                'discountedProductCode': 'AmazonEC2',
                'productFamily': 'EC2InstanceSavingsPlans',
                'purchaseOption': 'AWS_NO_UPFRONT',
                'region': 'af-south-1'
            }
        }
        graphql url(service: service),
                format_request(
                    :bulkGetSavingsPlanProductRates,
                    service: service
                ),
                variables, apitest_headers
        expect_success_graphql
        check(:bulkGetSavingsPlanProductRates, service: service)

        expect_json 'data.bulkGetSavingsPlanProductRates',
                    contentLength: -> (contentLength){ expect(contentLength).to be > 0 },
                    contentType: 'application/json-lines'
      end
    end
  end
end
