require 'spec_helper'

module SPBulkAPIECSPricingTest
  describe 'Bulk API Savings Plans ECS Pricing' do
    include_context 'request metadata'
    it 'Bulk API Query to get SP ECS Price for ComputeSavingsPlans' do
      wrap_request do
        variables = {
          'queryReq': {
            'customerId': 57534,
            'payerAccountId': 'ALL',
            'discountedProductCode': 'AmazonECS',
            'productFamily': 'ComputeSavingsPlans'
          }
        }
        graphql url(service: service),
                format_request(
                  :bulkGetSavingsPlanProductRates,
                  service: service
                ),
                variables, apitest_headers
        expect_success_graphql
        check(:bulkGetSavingsPlanProductRates, service: service)

        expect_json 'data.bulkGetSavingsPlanProductRates',
                    contentLength: -> (contentLength){ expect(contentLength).to be > 0 },
                    contentType: 'application/json-lines'
      end
    end

    it 'E: Bulk API Query to get SP ECS Price for EC2InstanceSavingsPlans' do
      wrap_request do
        variables = {
            'queryReq': {
                'customerId': 57534,
                'payerAccountId': 'ALL',
                'discountedProductCode': 'AmazonECS',
                'productFamily': 'EC2InstanceSavingsPlans'
            }
        }
        graphql url(service: service),
                format_request(
                    :bulkGetSavingsPlanProductRates,
                    service: service
                ),
                variables, apitest_headers
        expect_error_graphql(
                    status: 200,
                    errors: [{ message: '[EC2InstanceSavingsPlans is not a valid product family for AmazonECS savings plan]' }]
                )
      end
    end
  end
end
