require 'spec_helper'

module OnDemandRedshiftPricingTest
  describe 'On Demand Redshift Pricing' do
    include_context 'request metadata'
#     TODO: Update: Remove tenancy field from select fields
    it 'Query Redshift OD Price for Non-EDP Customer' do
      pending 'TITANS-538'
      wrap_request do
        variables = {
          'queryReq': {
            'customerId': 57534,
            'payerAccountId': 'ALL',
            'purchaseOption': 'ON_DEMAND',
            'region': 'us-east-1',
            'productCode': 'AmazonRedshift'
          }
        }
        graphql url(service: service),
                format_request(
                  :getAwsLeasableComputeProductRate,
                  service: service
                ),
                variables, apitest_headers
        expect_success_graphql
        check(:getAwsLeasableComputeProductRate, service: service)

        # No discount for all the line items for the 'CHT' customer
        expect(
            json_body[:data][:getAwsLeasableComputeProductRate].all? do |redshift|
              redshift[:discountedRate] == redshift[:publicRate]
            end
        ).to be true

        expect_json 'data.getAwsLeasableComputeProductRate.*',
                    productCode: 'AmazonRedshift',
                    productFamily: 'Compute Instance',
                    purchaseOption: 'On Demand',
                    locationName: 'us-east-1',
                    cacheEngine: nil,
                    offeringClass: nil,
                    leaseContractLength: 0,
                    usageFamily: regex("Dense Storage|Dense Compute")
      end
    end

# TODO: https://cloudhealthtech.atlassian.net/browse/ZEUS-5915
    it 'Query Redshift OD Price for EDP Customer' do
      pending 'TITANS-538'
      wrap_request do
        variables = {
            'queryReq': {
                 'customerId': 57534,
                'payerAccountId': 'ALL',
                'purchaseOption': 'ON_DEMAND',
                'region': 'us-east-1',
                'productCode': 'AmazonRedshift'
            }
        }
        graphql url(service: service),
                format_request(
                    :getAwsLeasableComputeProductRate,
                    service: service
                ),
                variables, apitest_headers
        expect_success_graphql
        check(:getAwsLeasableComputeProductRate, service: service)

        # 22% discount for all the line items for the 'RedShirt' customer
        expect(
            json_body[:data][:getAwsLeasableComputeProductRate].all? do |redshift|
              (100 - (redshift[:discountedRate] / redshift[:publicRate] * 100).round).eql? 22
            end
        ).to be true

        expect_json 'data.getAwsLeasableComputeProductRate.*',
                    productCode: 'AmazonRedshift',
                    productFamily: 'Cache Instance',
                    purchaseOption: 'On Demand',
                    locationName: 'us-east-1',
                    cacheEngine: nil,
                    offeringClass: nil,
                    leaseContractLength: 0,
                    usageFamily: regex("Dense Storage|Dense Compute")
      end
    end
  end
end
