require 'spaceborne'
require 'cht-chaphql'
require 'curlyrest'

Dir[File.join(__dir__, '../lib/*', '*.rb')].each { |file| require file }
Dir[File.join(__dir__, 'helpers/*.rb')].each { |f| require f }

RSpec.configure do |c|
  c.include Chaphql
  c.include Chaphql::GraphQLHelpers
  c.include Chaphql::AnalyzerHelpers
  c.include Chaphql::StringManipulation
  c.include Chaphql::ServiceHelper
  c.include Chaphql::IntrospectConflict
  c.include Spaceborne
  c.filter_run_excluding(save_schema: true)
  # c.filter_run_excluding(not_via_preprod: true) if ENV['TEST_ENV'].eql? 'preprod'
  c.shared_context_metadata_behavior = :apply_to_host_groups
end

RSpec.shared_context 'request metadata', shared_context: :metadata do
  let(:via_public) { %w{prod staging preprod canary}.include?(getenv) }
  let(:service) { ChtApitestPricing::PricingService.new }
  let(:dbg_headers) { headers.merge(use_curl: 'debug') }
end

RSpec.configure do |c|
  c.include_context 'request metadata', include_shared: true
end
